//+------------------------------------------------------------------+
//|                                                3 Ducks Alert.mq4 |
//| This is a multi-symbol indicator for                             |
//| Andy's 3 Ducks System. It can monitor                            |
//| 1 or more symbols and can be set with                            |
//| an alert.
//| Modified By GumRai                           |                                                        |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 SeaGreen

extern string allsymbol = "EURUSD,GBPUSD,AUDUSD,NZDUSD,USDJPY,USDCAD,USDCHF,AUDJPY,EURJPY,GBPJPY,CADJPY,EURGBP,EURAUD,EURCAD,#CLG4,XAUUSD"; // all symbols, comma separated
extern bool SetAlert = True;

int NumOfPairs = 0;
string Pairs[];
double CrossUp[], alertTag;

int init()
{ SetIndexStyle(0, DRAW_ARROW, EMPTY,1);
  SetIndexArrow(0, 234);
  SetIndexBuffer(0, CrossUp);
  NumOfPairs=StringSplit(allsymbol,StringGetCharacter(",",0),Pairs);
  
  ObjectCreate("InfoSection",OBJ_LABEL,0,0,0);
  ObjectSet("InfoSection",OBJPROP_XDISTANCE,4);
  ObjectSet("InfoSection",OBJPROP_YDISTANCE,20);
  color col=ChartGetInteger(0,CHART_COLOR_FOREGROUND,0);
  ObjectSetText("InfoSection","Symbol   -   H4   -   H1  -  M5",8,"Arial",col);
  for (int j=0;j<NumOfPairs;j++)
  { int startheight = 30;
    string thissymbol = Pairs[j];
    ObjectCreate("symbol"+j,OBJ_LABEL,0,0,0);
    ObjectSet("symbol"+j,OBJPROP_XDISTANCE,4);
    ObjectSet("symbol"+j,OBJPROP_YDISTANCE,startheight+j*15);
    ObjectSetText("symbol"+j,thissymbol,8,"Arial",col);
    ObjectCreate("h4"+j,OBJ_LABEL,0,0,0);
    ObjectSet("h4"+j,OBJPROP_XDISTANCE,60);
    ObjectSet("h4"+j,OBJPROP_YDISTANCE,startheight+j*15);
    ObjectCreate("h1"+j,OBJ_LABEL,0,0,0);
    ObjectSet("h1"+j,OBJPROP_XDISTANCE,90);
    ObjectSet("h1"+j,OBJPROP_YDISTANCE,startheight+j*15);
    ObjectCreate("m5"+j,OBJ_LABEL,0,0,0);
    ObjectSet("m5"+j,OBJPROP_XDISTANCE,120);
    ObjectSet("m5"+j,OBJPROP_YDISTANCE,startheight+j*15);
  }
  return(0);
}

int deinit()
{ ObjectDelete("InfoSection");
  for (int j=0;j<NumOfPairs;j++)
  { ObjectDelete("symbol"+j);
    ObjectDelete("h4"+j);
    ObjectDelete("h1"+j);
    ObjectDelete("m5"+j);
  }
  return(0);
}

int start()
{ string h4txt, h1txt, m5txt;
  color h4clr, h1clr, m5clr;
  
  for (int i=0;i<NumOfPairs;i++)
  { string thissymbol = Pairs[i];
    double sma60h4 = iMA(thissymbol,PERIOD_H4,60,0,MODE_SMA,PRICE_CLOSE,0);
    double sma60h1 = iMA(thissymbol,PERIOD_H1,60,0,MODE_SMA,PRICE_CLOSE,0);
    double sma60m51 = iMA(thissymbol,PERIOD_M5,60,0,MODE_SMA,PRICE_CLOSE,0);
    double sma60m52 = iMA(thissymbol,PERIOD_M5,60,0,MODE_SMA,PRICE_CLOSE,1);
    
    if (iClose(thissymbol,PERIOD_H4,0) > sma60h4)
    { h4txt = "bull";
      h4clr = Green;
    }
    else
    { h4txt = "bear";
      h4clr = Red;
    }
    if (iClose(thissymbol,PERIOD_H1,0) > sma60h1)
    { h1txt = "bull";
      h1clr = Green;
    }
    else
    { h1txt = "bear";
      h1clr = Red;
    }
    if (iClose(thissymbol,PERIOD_M5,0) > sma60m51)
    { m5txt = "bull";
      m5clr = Green;
    }
    else
    { m5txt = "bear";
      m5clr = Red;
    }
    ObjectSetText("h4"+i,h4txt,8,"Arial",h4clr);
    ObjectSetText("h1"+i,h1txt,8,"Arial",h1clr);
    ObjectSetText("m5"+i,m5txt,8,"Arial",m5clr);
    if (SetAlert && alertTag != iTime(thissymbol,PERIOD_M5,0))
    { if (h4txt == "bull" && h1txt == "bull" && m5txt == "bull" && iHigh(thissymbol,PERIOD_M5,1) < sma60m52)
      { Alert("Bull trend on all 3 TF for ",thissymbol);
        alertTag = iTime(thissymbol,PERIOD_M5,0);
      }
      else if (h4txt == "bear" && h1txt == "bear" && m5txt == "bear" && iLow(thissymbol,PERIOD_M5,1) > sma60m52)
      { Alert("Bear trend on all 3 TF for ",thissymbol);
        alertTag = iTime(thissymbol,PERIOD_M5,0);
      }
    }
  }
  CrossUp[0] = 0;
  return(0);
}